'ErrCode =  0 - Operation Successful
'ErrCode =  1 - Not DBF File
'ErrCode =  2 - More than 100 fields
'ErrCode =  3 - Path/File Access Error
'ErrCode =  4 - Illegal FileStat% Handle
'ErrCode =  5 - File Already Open; File Handle Active
'ErrCode =  6 - Past EOF
'ErrCode =  7 - Bad Record No.
'ErrCode =  8 - Change in Record Count
'ErrCode =  9 - File not open
'ErrCode = 10 - File Handle & DBF Structure Incompatibility
'ErrCode = 11 - Bad Field No
'ErrCode = 12 - Null or Illegal Date Field Value
'ErrCode = 13 - Field Type Modified
'ErrCode = 14 - Caution Linear Tendency on BTree Index
'ErrCode = 15 - BTree Index Corrupt
'ErrCode = 16 - Bad Index Number or Index Name
'ErrCode = 17 - Not an HDX File
'ErrCode = 18 - Index Empty
'ErrCode = 19 - DBF Header - NdxHdr Incompatability
'ErrCode = 20 - Stack Space Exhausted (Linear BTree Index)
'ErrCode = 21 - Index not Empty on Rebuild/Set
'ErrCode = 22 - Hdx File already exists on MakeHdx
'ErrCode = 23 - No Index Template Created or error on
'               create before defining keys
'ErrCode = 24 - Tried to define more than 10 keys for template
'ErrCode = 25 - Field name not found
'ErrCode = 26 - Template Name for index already exists
'ErrCode = 27 - Hdx File Full
'ErrCode = 28 - No Key Template Created or error on Key_on_...
'               for defining keys

'******** Parameters that return values:
'FileStat%  (OpenDbf)  - 0 Close on exit
'FileStat%  (OpenDbf)  - X Open on exit with FileHandle X
'FldVal#    (Getfield) - Double Precision number  for GetField% = 1
'FldVal$    (Getfield) - String value information for GetField% = 2,3,4,5

'*********Functions that return values:
'GetField%  Rtn Value - 1 Numeric (Double) Field Type
'GetField%  Rtn Value - 2 String Field Type
'GetField%  Rtn Value - 3 Date Field Type ("mm/dd/yyyy")
'GetField%  Rtn Value - 4 Logical String ("T" or "F") Field Type
'GetField%  Rtn Value - 5 Memo Field Type

'GetFldNum% Rtn Value - 0 Field Not found
'GetFldNum% Rtn Value - X Field Name's Number

'GetNdxNum% Rtn Value - 0 Index Not Found
'GetNdxNum% Rtn Value - X Index number in HDX file

'OpenHdx%  Return Val - X HDX File Handle

'******For Traverse Routine***********************
'If Operation% = 1 Then
' If Direction% = 1 Then     ASCENDING
'  Traverse from >= Value$
' else
'  Traverse from Root
'
'If Operation% = 2 Then
' If Direction% = 2 Then     DESCENDING
'  Traverse from <= Value$
' else
'  Traverse from Root
'*************************************************
Example:
'Direction% = 1 and Operation% = 0 then Ascending for all
'Direction% = 2 and Operation% = 0 then Descending for all
'*************************************************




DEFINT A-Z
'*******************************
'$INCLUDE: 'ndxpack.bi'
'*******************************
'$FORM Form1
  DBFile = 1             'Set DBFile handle to leave file open on exit
  
  StkSpace& = 7500       'These two statements allow you to control the
  STACK (StkSpace&)      'amount of space to allocate for the stack at
                         'run time (default 3K) balance use of this
                         'against the ability to reindex your HDX files
                         'should they become large and unbalanced.


 'Test.dbf & Test.hdx were files included in the demo NDXDBF.EXE found in the
 'same forum as these files; however, EXAM2.BAS shows how you can build
 'Test.hdx from scratch if you already have Test.Dbf

 OpenDbf "Test.dbf", ErrCode, DBFile           'Open the database
 NdxFile = OpenHdx%("Test.hdx", ErrCode)       'Open associated HDX File

'**************************************************************************

 GetHdr NdxFile, 1, ErrCode, NdxHdr            'Get the First Index
 Traverse 1, ErrCode, 0                        'Set traverse for ascending
                                               'which loads Form1 through
                                               'Nexus.Bas
 Form1.SHOW 1                                  'Show Form1 after traverse

'**************************************************************************

 GetHdr NdxFile, 2, ErrCode, NdxHdr            'Do the same thing for
 Traverse 1, ErrCode, 0                        'INDEX 2
 Form1.SHOW 1

'**************************************************************************

 GetHdr NdxFile, 3, ErrCode, NdxHdr            'Do the same thing for
 Traverse 1, ErrCode, 0                        'INDEX 3
 Form1.SHOW 1

'**************************************************************************

 GetHdr NdxFile, 4, ErrCode, NdxHdr            'Do the same thing for
 Traverse 1, ErrCode, 0                        'INDEX 4
 Form1.SHOW 1

END


