; EXAMP1.ASM: routine which acts similar to INSTR: takes main string (of any
; length) and match string (length = 1 character), and returns (as an
; integer) the position (1..length) of the first occurrence of the match
; string in the main string.  If the match string doesn't exist in the main
; string, the routine returns zero.

; Usage: $LINK "EXAMP1.OBJ"
;        DECLARE FUNCTION MyInstr%(STRING, STRING)
;        position% = MyInstr%(main$, match$)

extrn get$loc: far

code segment byte public
assume cs:code

MyInstr		proc	far
		public	MyInstr

		push	bp
		mov	bp, sp
		push	di		  ; preserve di for PowerBASIC

		les	di, [bp][06]	  ; es:di points to match$ handle
		push	word ptr es:[di]  ; push handle on stack for get$loc
		call	get$loc		  ; dx:ax = match$, cx = length
		mov	bx, cx		  ; save length in bx for now
		mov	di, ax
		mov	es, dx		  ; es:di points to match$ contents
		mov	al, es:[di]	  ; al = 1st character of match$
		push	ax		  ; save on stack for now

		les	di, [bp][0Ah]	  ; es:di points to main$ handle
		push	word ptr es:[di]  ; push handle on stack for get$loc
		call	get$loc		  ; dx:ax = main$, cx = length
		mov	di, ax
		mov	es, dx		  ; es:di points to main$ contents
		pop	ax		  ; al = match$ character
		jcxz	MyZero		  ; return zero if main$ length = 0
		or	bx, bx		  ; check if match$ length = 0
		jz	MyOne		  ; return one if match$ null
		mov	bx, di		  ; save start offset of main$ in bx

		cld			  ; clear dir flag for forward scan
		repne	scasb		  ; scan cx bytes for match with al
		jnz	MyZero		  ; return zero if no match
		sub	di, bx		  ; di = match+1 - start = position
					  ; (1..len) of match$ in main$
		mov	ax, di		  ; put it in ax for return to PB
		jmp	short MyFound
MyOne:
		mov	ax, 1		  ; ax = 1 if match$ null
		jmp	short MyFound
MyZero:
		xor	ax, ax		  ; ax = zero (returns zero to PB)
MyFound:
		pop	di		  ; restore di and bp
		pop	bp		  ; okay to leave dir flag clear
		retf	8		  ; far return, remove 8 bytes

MyInstr		endp

code ends
end
