; EXAMP2.ASM: This routine takes two main strings and an error string as
; parameters.  It concatenates the two main strings into a new result string
; which is then returned to PowerBASIC.  If the new string cannot be created
; (because there is not enough string space left or because the resulting
; string would be longer than the maximum string size), the error string is
; returned instead.

; Usage: $LINK "EXAMP2.OBJ"
;        DECLARE FUNCTION MyCat$(STRING, STRING, STRING)
;        myerror$ = "You blew it!"
;        cat$ = MyCat$(string1$, string2$, myerror$)

extrn get$loc: far
extrn get$alloc: far

code segment byte public
assume cs:code

MyCat		proc	far
		public	MyCat

		push	bp
		mov	bp, sp
		push	si		  ; preserve si, di, ds for PB
		push	di
		push	ds

		les	di, [bp][0Ah]	  ; es:di points to string2$ handle
		push	word ptr es:[di]  ; push handle on stack for get$loc
		call	get$loc		  ; dx:ax = string2$, cx = length
		mov	bx, cx		  ; save length in bx for now
		push	cx		  ; save length for now on stack too
		push	ax		  ; save address of contents for now
		push	dx

		les	di, [bp][0Eh]	  ; es:di points to string1$ handle
		push	word ptr es:[di]  ; push handle on stack for get$loc
		call	get$loc		  ; dx:ax = string1$, cx = length
		push	cx		  ; save length for now
		push	ax		  ; save address of contents for now
		push	dx

		add	cx, bx		  ; cx = length of both strings
		cmp	cx, 32750	  ; make sure it's not > max $ size
		ja	MyCatError	  ; return error string if it is

		push	cx		  ; request cx bytes from get$alloc
		call	get$alloc	  ; ax = handle # or 0 if error
		or	ax, ax		  ; see if ax = 0
		jz	MyCatError	  ; yes, go return error$ to PB
		mov	bx, ax		  ; save handle in bx for later

		push	ax		  ; new handle on stack for get$loc
		call	get$loc		  ; dx:ax = new$, cx = length
		mov	di, ax
		mov	es, dx		  ; es:di points to start of new$

		pop	ds
		pop	si
		pop	cx		  ; ds:si = string1$, cx = length
		cld			  ; clear dir flag for forward copy
		rep	movsb		  ; copy string1$ to new$

		pop	ds
		pop	si
		pop	cx		  ; ds:si = string2$, cx = length
		rep	movsb		  ; append string2$ to new$

		mov	ax, bx		  ; return new$ handle to PB in ax
MyCatDone:
		pop	ds		  ; restore ds, di, si, bp
		pop	di
		pop	si
		pop	bp		  ; okay to leave dir flag clear
		retf	12		  ; far return, remove 12 bytes

MyCatError:				  ; here if not able to create new
		add	sp, 6*2		  ; string -- clean the 6 extra
		les	di, [bp][06]	  ; words off the stack (cx, ax, dx,
		mov	ax, es:[di]	  ; cx, ax, dx), get the handle of
		jmp	MyCatDone	  ; the error string off the stack
					  ; and return it in ax
MyCat		endp

code ends
end
