; EXAMP5.ASM: This routine locates the largest element in an integer array
; and returns its relative index, given the start element and the number of
; consecutive elements to search.

; Usage: $LINK "EXAMP5.OBJ"
;        DECLARE FUNCTION Largest%(INTEGER, INTEGER)
;	 DIM TheArray%(1:100)
;	 'next line searches 20 elements starting at element 5
;        bigindex% = Largest%(TheArray%(5), 20)  'returns 0..19
;	 bigvalue% = TheArray%(bigindex%+5)      'now use index to get value

code segment byte public
assume cs:code

Largest		proc	far
		public	Largest

		push	bp
		mov	bp, sp
		push	di		  ; preserve di for PowerBASIC

		les	di, [bp][06]	  ; es:di points to # of elements
		mov	cx, es:[di]	  ; cx = # of elements
		les	di, [bp][0Ah]	  ; es:di = array start address
		push	di		  ; save array start offset

		mov	bx, es:[di]	  ; bx holds current largest value
		mov	dx, di		  ; dx holds its offset
GetInteger:
		mov	ax, es:[di]	  ; get next value
		cmp	ax, bx		  ; compare against current largest
		jbe	Smaller		  ; go get next if < current largest
		mov	bx, ax		  ; > current largest so make it new
		mov	dx, di		  ; current largest & record offset
Smaller:
		inc	di		  ; advance pointer to next integer
		inc	di		  ; (2 bytes per integer)
		loop	GetInteger	  ; get next until # of elements done

		pop	di		  ; get array start offset
		sub	dx, di		  ; dx = ofst (0..(#-1)*2) of largest
		shr	dx, 1		  ; divide by 2 giving 0..#-1
		mov	ax, dx		  ; put in ax for return to PB

		pop	di		  ; restore di and bp
		pop	bp
		retf	8		  ; far return, remove 8 bytes

Largest		endp

code ends
end
