'Set up DBF Structures
TYPE DBFHeadStruc
  Version  AS INTEGER
  Memo     AS INTEGER
  Ano      AS INTEGER
  Mes      AS INTEGER
  Dia      AS INTEGER
  FirstRec AS INTEGER
  TRecs    AS LONG
  RecLen   AS INTEGER
  TFields  AS INTEGER
END TYPE

TYPE FieldStruc
  FName AS STRING * 10
  FType AS STRING * 1
  FOff  AS INTEGER
  FLen  AS INTEGER
  Dec   AS INTEGER
END TYPE

TYPE DBFileType
 FName AS STRING * 8
 Status AS INTEGER
 FileNo AS INTEGER
 Fields(100) AS FieldStruc
 Header AS DBFHeadStruc
END TYPE
'*******************************
'NDXPack Structures
TYPE NdxNode
 RecNo AS LONG
 Prnt AS LONG
 LChld AS LONG
 RChld AS LONG
 Addr AS LONG
END TYPE

TYPE FCBlk
 FNum AS INTEGER
 FType AS STRING * 1
 FLen AS INTEGER
END TYPE

TYPE StkType
 Addr1 AS LONG
 Addr2 AS LONG
 Addr3 AS LONG
 Nxt AS LONG
 Addr AS LONG
END TYPE

TYPE NdxVol
 Flag AS INTEGER
 TName AS STRING * 8
 Dname AS STRING * 8
 HdrLng AS INTEGER
 RecLng AS INTEGER
 Unq AS INTEGER
 TRecs AS LONG
 Root AS NdxNode
 FldCnt AS INTEGER
 KeyFld(0 TO 9) AS FCBlk
END TYPE
'*********************************
'Interrupt Structures
TYPE RegTypeX
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
     ds    AS INTEGER
     es    AS INTEGER
END TYPE

TYPE DTA
  Reserved  AS STRING * 21
  Attribute AS STRING * 1
  FileTime  AS STRING * 2
  FileDate  AS STRING * 2
  FileSize  AS LONG
  FileName  AS STRING * 13
END TYPE
'****************************************************************************
COMMON SHARED Registers AS RegTypeX
COMMON SHARED inreg AS RegTypeX, outreg AS RegTypeX
COMMON SHARED DTAData AS DTA
DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)
'****************************************************************************
COMMON SHARED DBF AS DBFileType, DBFRecord AS STRING * 4000
COMMON SHARED FldVal$, FldVal#
COMMON SHARED NdxHdr AS NdxVol, Node AS NdxNode, NewNode AS NdxNode
COMMON SHARED StkElem AS StkType, NewStkElem AS StkType, TempNode AS NdxNode
COMMON SHARED UBnd&, D1&, CurrentRecord&, StkSpace&, NdxAddr&
COMMON SHARED NdxFile%, Same%, Strng$, Value$
CONST LeftSide = 1, RightSide = 2
CONST FLenAddr = 997, StkLoc = 973
CONST InsFlg$ = "@", Delete$ = "*"
CONST False = 0, True = NOT False
'****************************************************************************
DECLARE FUNCTION FindFile% (FileStr$)
DECLARE FUNCTION VerifyField% (FileStat%, FieldNum%)
DECLARE SUB OpenDbf (FileStr$, ErrCode%, FileStat%)
DECLARE SUB CloseDbf (FileStat%)
DECLARE SUB DelRecord (FileStat%, RecNo&, ErrCode%)
DECLARE SUB UndelRec (FileStat%, RecNo&, ErrCode%)
DECLARE SUB GetRecord (FileStat%, RecNo&, DelState%, ErrCode%)
DECLARE SUB PutRecord (FileStat%, RecNo&, ErrCode%)
DECLARE SUB UpdateFld (FieldNum%, FldVal$, FldVal#, ErrCode%)
DECLARE FUNCTION GetFldNum% (FileStat%, FldName$, ErrCode%)
DECLARE FUNCTION GetField% (FileStat%, FieldNum%, ErrCode%)

'HDX Binary Tree Index Operations
DECLARE SUB NdeIns (FileStat%, RecNo&, ErrCode%)
DECLARE SUB DelNde (RecNo&, ErrCode%)
DECLARE SUB NdeDel (Node AS NdxNode)
DECLARE SUB NdeDelRoot (Node AS NdxNode)
DECLARE SUB NdeTravA (Operation%, TempNode AS NdxNode)
DECLARE SUB NdeTravD (Operation%, TempNode AS NdxNode)
DECLARE SUB DeleteNDX (NdxHdr AS NdxVol, ErrCode%)
DECLARE SUB DelTrav (ErrCode%, TempNode AS NdxNode)
DECLARE SUB Traverse (Direction%, ErrCode%, Operation%)
DECLARE SUB NextRec (FileStat%, RecNo&, Strng$, Operation%, NdxPos&)

'HDX File Operations
DECLARE SUB MakeHdx (FileStr$, ErrCode%)
DECLARE FUNCTION NdxTemplate$ (DBF AS DBFileType, NdxName$, UniqueFlg%)
DECLARE SUB Key_by_Name (NTemplate$, KeyName$, ErrCode%)
DECLARE SUB Key_by_Numb (NTemplate$, KeyNum%, ErrCode%)
DECLARE SUB SetNdx (FileStat%, NTemplate$, NdxNum%, ErrCode%)
DECLARE FUNCTION GetNdxNum% (FileStat%, NdxName$, ErrCode%)
DECLARE FUNCTION OpenHdx% (FileStr$, ErrCode%)
DECLARE SUB GetHdr (FileStat%, NdxNum%, ErrCode%, NdxHdr AS NdxVol)

'HDX Maintenance DLnkLst Stack Operations
DECLARE SUB StkPut (NewStkElem AS StkType)
DECLARE SUB StkPop (Addr&)
DECLARE SUB Convert (Addr&)

'HDX DBF Read & Compare on the Fly Operations
DECLARE FUNCTION ChkSum% (Node AS NdxNode)
DECLARE FUNCTION CmpValue% (FileStat%, Addr&)
DECLARE FUNCTION GetCmpVal$ (FileStat%, Addr&)

'HDX Recursive Random Range Number Generator Algorithm
DECLARE SUB Build (FileStat%, ErrCode%)
DECLARE SUB RecurRecno (FileStat%, D1&, Iter%, I&, K&)
DECLARE FUNCTION Pcnt! ()
DECLARE FUNCTION IFlg$ (FileStat%, RecNo&, Addr&)

