DEFINT A-Z
'*****************************
'$INCLUDE: 'ndxpack.BI'
'*****************************
'$FORM Form1

'ErrCode =  0 - Operation Successful
'ErrCode =  1 - Not DBF File
'ErrCode =  2 - More than 100 fields
'ErrCode =  3 - Path/File Access Error
'ErrCode =  4 - Illegal FileStat% Handle
'ErrCode =  5 - File Already Open; File Handle Active
'ErrCode =  6 - Past EOF
'ErrCode =  7 - Bad Record No.
'ErrCode =  8 - Change in Record Count
'ErrCode =  9 - File not open
'ErrCode = 10 - File Handle & DBF Structure Incompatibility
'ErrCode = 11 - Bad Field No
'ErrCode = 12 - Null or Illegal Date Field Value
'ErrCode = 13 - Field Type Modified
'ErrCode = 14 - Caution Linear Tendency on BTree Index
'ErrCode = 15 - BTree Index Corrupt
'ErrCode = 16 - Bad Index Number or Index Name
'ErrCode = 17 - Not an HDX File
'ErrCode = 18 - Index Empty
'ErrCode = 19 - DBF Header - NdxHdr Incompatability
'ErrCode = 20 - Stack Space Exhausted (Linear BTree Index)
'ErrCode = 21 - Index not Empty on Rebuild/Set
'ErrCode = 22 - Hdx File already exists on MakeHdx
'ErrCode = 23 - No Index Template Created or error on
'               create before defining keys
'ErrCode = 24 - Tried to define more than 10 keys for template
'ErrCode = 25 - Field name not found
'ErrCode = 26 - Template Name for index already exists
'ErrCode = 27 - Hdx File Full
'ErrCode = 28 - No Key Template Created or error on Key_on_...
'               for defining keys

'******** Parameters that return values:
'FileStat%  (OpenDbf)  - 0 Close on exit
'FileStat%  (OpenDbf)  - X Open on exit with FileHandle X
'FldVal#    (Getfield) - Double Precision number  for GetField% = 1
'FldVal$    (Getfield) - String value information for GetField% = 2,3,4,5

'*********Functions that return values:
'GetField%  Rtn Value - 1 Numeric (Double) Field Type
'GetField%  Rtn Value - 2 String Field Type
'GetField%  Rtn Value - 3 Date Field Type ("mm/dd/yyyy")
'GetField%  Rtn Value - 4 Logical String ("T" or "F") Field Type
'GetField%  Rtn Value - 5 Memo Field Type

'GetFldNum% Rtn Value - 0 Field Not found
'GetFldNum% Rtn Value - X Field Name's Number

'GetNdxNum% Rtn Value - 0 Index Not Found
'GetNdxNum% Rtn Value - X Index number in HDX file

'OpenHdx%  Return Val - X HDX File Handle

'******For Traverse Routine***********************
'If Operation% = 1 Then
' If Direction% = 1 Then     ASCENDING
'  Traverse from >= Value$
' else
'  Traverse from Root
'
'If Operation% = 2 Then
' If Direction% = 2 Then     DESCENDING
'  Traverse from <= Value$
' else
'  Traverse from Root
'*************************************************
Example:
'Direction% = 1 and Operation% = 0 then Ascending for all
'Direction% = 2 and Operation% = 0 then Descending for all
'*************************************************

'*************************************************************
'Use Operation% (Set In Traverse) to code subroutine flow.
'Set Operation% to -1 to terminate Traverse before completion.
'STRNG$ contains string information for Index Key Value.
'NdxPos& is offset in HDX file for Index Position of RecNo&
'*************************************************************
STATIC SUB NextRec (FileStat%, RecNo&, Strng$, Operation%, NdxPos&)
 CurrentRecord& = RecNo&
 SELECT CASE Operation%
  CASE 0, 1, 2
   IF Operation% = 0 THEN
    '***********Traverse for all*************
    Form1.List1.ADDITEM FORMAT$(RecNo&, "000000 ") + FORMAT$(NdxPos&, "00000000 ") + Strng$
   ELSEIF Operation% = 1 THEN
    '***********Traverse starting from Value$ ascending***********
    IF UCASE$(MID$(Strng$, 1, LEN(Value$))) >= Value$ THEN
     Form1.List1.ADDITEM FORMAT$(RecNo&, "000000 ") + FORMAT$(NdxPos&, "00000000 ") + Strng$
    END IF
   ELSE
    '***********Traverse starting from Value$ descending**********
    IF UCASE$(MID$(Strng$, 1, LEN(Value$))) <= Value$ THEN
     Form1.List1.ADDITEM FORMAT$(RecNo&, "000000 ") + FORMAT$(NdxPos&, "00000000 ") + Strng$
    END IF
   END IF
  CASE 32767                       '***This is special case set by call from
   IF RecNo& = Node.RecNo THEN     '   SUB DelNde
    Operation% = -1
    DelRecord FileStat%, RecNo&, ErrCode%
    GET #NdxFile, NdxPos&, Node
    NdeDel Node
   END IF
 'CASE OTHERS*******Any other cases you would stick in here to suit needs
  CASE ELSE
 END SELECT

 'This just sets the Operation/Filestat status display on Form1

 Buf$ = FORMAT$(FileStat%, "0000") + SPACE$(8) + FORMAT$(Operation%, "0")
 Form1.Label3.Caption = Buf$

END SUB

